/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ESTA                                                     */
/* Tabela : ESTADO                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 22/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ESTA
BEFORE INSERT OR UPDATE OR DELETE
ON ESTADO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUESTA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPAIS,0)   <> NVL(:NEW.CDPAIS,0))   OR
         (NVL(:OLD.SGESTADO,0) <> NVL(:NEW.SGESTADO,0)) OR
         (NVL(:OLD.NMESTADO,0) <> NVL(:NEW.NMESTADO,0)) OR
         (NVL(:OLD.CDESTADOIBGE,0) <> NVL(:NEW.CDESTADOIBGE,0)) THEN
         :NEW.DTULTATUESTA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ESTADO', '', 'CDPAIS='||:OLD.CDPAIS||';SGESTADO='||:OLD.SGESTADO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ESTADO MODIFY DTULTATUESTA DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ESTA','5.11.000'); END;
/
